#define NDEBUG // disable assertion messages for boost multi_arrays
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <iostream.h>
//#include <fcntl.h>
#include <io.h>
#include <sstream>
#include <algorithm>    // std::copy
#include <boost/array.hpp>
#include <boost/multi_array.hpp>
#include <boost/lexical_cast.hpp>
#include <boost/algorithm/string.hpp>
//#include <cassert>
#include <iterator>
#define _POSIX_SOURCE
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
//#include <unistd.h>
#undef _POSIX_SOURCE
#include <windows.h>
#include <math.h>
#include <map>
#include <time.h>
#include <boost/date_time/gregorian/gregorian.hpp>

long isleapyear(long);
int DateFromSerial(double , long& , long& , long&, long&, long&, double&);
long dateserial (long,long,long);
int timedayofweek(double);
char* unix_time_to_datecpp(double);

using namespace std;

char* convert(const std::string & s)
{
   char *pc = new char[s.size()+1];
   std::strcpy(pc, s.c_str());
   return pc; 
}

char* rqmod (char* firstnumber,char* secondnumber)
{  

static char debugmsg[1000];

static char firstnumberr[1000];
strncpy(firstnumberr, firstnumber, 1000);

static char secondnumberr[1000];
strncpy(secondnumberr, secondnumber, 1000);

double firstnumberdbl=atof(firstnumberr);
double secondnumberdbl=atof(secondnumberr);

//sprintf(debugmsg,"%f",firstnumberdbl);MessageBox( NULL, debugmsg,"Debug",MB_OK); 
//sprintf(debugmsg,"%f",secondnumberdbl);MessageBox( NULL, debugmsg,"Debug",MB_OK); 
//sprintf(debugmsg,"%i",dayint);MessageBox( NULL, debugmsg,"Debug",MB_OK);

double resnum;
resnum=fmod (firstnumberdbl,secondnumberdbl);
//sprintf(debugmsg,"%f",resnum);MessageBox( NULL, debugmsg,"Debug",MB_OK); 
char catline[1000];
sprintf(catline,"%f",resnum);
return catline;
}

int DateFromSerial(double DateSerial , long & Year , long & Month , long & Day,long & Hour,long & Minute,double & Second) {
    //declare
    //long daysCount , dayOfMonth , dayTotal;//, isLeapYearlng;

static char debugmsg[1000];
//sprintf(debugmsg,"%f",DateSerial);MessageBox( NULL, debugmsg,"Debug",MB_OK);


long hoursrest=0;
    //string DateSerialstr=Format$("%12.0f", DateSerial)

    double secondsrest=fmod(DateSerial,86400);



    //defstr amodstr="86400"

    //defdbl secondsrest=val(varptr$(rqmod(varptr(DateSerialstr),varptr(amodstr))))

    Second=secondsrest;

    double secondsrest2=secondsrest;

    secondsrest=fmod(secondsrest2, 60);


 
    Second=secondsrest;  

    long minutesrest=secondsrest2 / 60;

 

    long minutesrest2=minutesrest;

    minutesrest=minutesrest2 % 3600;



    Minute=minutesrest;      

    if (minutesrest % 60==0) {
    minutesrest2=minutesrest;
    minutesrest=0;
    }         



    Minute=minutesrest % 60;  

  

    hoursrest=minutesrest2 / 60;



    Hour=hoursrest;       
    
    DateSerial=DateSerial/24/60/60;    
//sprintf(debugmsg,"%f",DateSerial);MessageBox( NULL, debugmsg,"Debug",MB_OK);


    long daysCount=0 , dayOfMonth=0 , dayTotal=0;
    DateSerial=DateSerial+719163;
//sprintf(debugmsg,"%f",DateSerial);MessageBox( NULL, debugmsg,"Debug",MB_OK);

//sprintf(debugmsg,"%u",dayTotal);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%u",dayOfMonth);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%u",daysCount);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%f",DateSerial);MessageBox( NULL, debugmsg,"Debug",MB_OK);


    //initialize
    Year = 1;
    Month = 1;
    daysCount = DateSerial - 1;
//sprintf(debugmsg,"%u",daysCount);MessageBox( NULL, debugmsg,"Debug",MB_OK);


    //pre-process
    if (daysCount > 146096) {
        Year = Year + (trunc(round(daysCount) / 146097)) * 400;
        daysCount = (daysCount % 146097);
    }



    if (daysCount > 36523) {
        dayTotal = trunc(round(daysCount) / 36524);
//sprintf(debugmsg,"%u",dayTotal);MessageBox( NULL, debugmsg,"Debug",MB_OK);
        if (dayTotal < 4) {
            Year = Year + (dayTotal * 100);
            daysCount = (daysCount % 36524);
	}
        else {
             Year = Year + 300;
             daysCount = 36524;
	     }        
    }


 
    if (daysCount > 1460) {
        Year = Year + (trunc(round(daysCount) / 1461)) * 4;
        daysCount = (daysCount % 1461);
    }


 
    if (daysCount > 364) {
        dayTotal = trunc(round(daysCount) / 365);
//sprintf(debugmsg,"%u",dayTotal);MessageBox( NULL, debugmsg,"Debug",MB_OK);
        if (dayTotal < 4) {
            Year = Year + dayTotal;
            daysCount = (daysCount % 365);
	}
        else {
            	Year = Year + 3;
            	daysCount = 365;
        	}
    }



    //process
    Day = daysCount + 1;
    dayOfMonth = 1040154527;
    //isLeapYearlng=isleapyear(Year);
    if ((Day > 58) && (isleapyear(Year))) dayOfMonth = (dayOfMonth + 32);

//sprintf(debugmsg,"%u",dayOfMonth);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%u",dayTotal);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%u",Day);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%u",Month);MessageBox( NULL, debugmsg,"Debug",MB_OK);

    do
	{
        dayTotal = (dayOfMonth & 31);
        if (dayTotal >= Day) break;
        Day = Day - dayTotal;
        Month = Month + 1;
        dayOfMonth = (trunc(round(dayOfMonth) / 32));
        if (dayOfMonth == 0) dayOfMonth = 1072692223;
    	}
    	while (1==1);
//sprintf(debugmsg,"%s","17");MessageBox( NULL, debugmsg,"Debug",MB_OK); 


    //exit
    return (0);
}

long isleapyear(long year)
{
    if ( ( (year % 4) == 0) && ( (year % 100) > 0) || ( (year % 400) == 0) ) return 1;
    else return 0;
}

char* unix_time_to_date_old(char* unix_time)
{
static char unix_timee[1000];
strncpy(unix_timee, unix_time, 1000);

	//const char time_as_str[] = "1296575549:573352";
	time_t t = atoi(unix_timee); // convert to time_t, ignores msec
	char asctimechar[1000];
	sprintf(asctimechar,"%s",asctime(gmtime(&t)));
	return asctimechar;
}

char* unix_time_to_date(char* DateSerialchar)
  {


static char DateSerialcharr[1000];
    strncpy(DateSerialcharr, DateSerialchar, 1000);
    double dblDateSerialchar=atof(DateSerialcharr);

 double DateSerialdbl=dblDateSerialchar;
static long Yearlng;
static long Monthlng;
static long Daylng;
static long Hourlng;
static long Minutelng;
static double Seconddbl;

//DateSerialdbl=1111111111;
static char debugmsg[1000];
//sprintf(debugmsg,"%f",DateSerialdbl);MessageBox( NULL, debugmsg,"Debug",MB_OK); 

DateFromSerial(DateSerialdbl , Yearlng , Monthlng , Daylng,Hourlng,Minutelng,Seconddbl);

long Secondlng=Seconddbl;

//sprintf(debugmsg,"%u",Yearlng);MessageBox( NULL, debugmsg,"Debug",MB_OK); 

char Yearlngchar[1000];
sprintf(Yearlngchar,"%u",Yearlng);

char Monthlngchar[1000];
sprintf(Monthlngchar,"%u",Monthlng);

char Daylngchar[1000];
sprintf(Daylngchar,"%u",Daylng);

char Hourlngchar[1000];
sprintf(Hourlngchar,"%u",Hourlng);

char Minutelngchar[1000];
sprintf(Minutelngchar,"%u",Minutelng);

char Seconddblchar[1000];
sprintf(Seconddblchar,"%u",Secondlng);


//std::string Yearlngcharstr (Yearlngchar);
//std::string Monthlngcharstr (Monthlngchar);
//std::string Daylngcharstr (Daylngchar);
//std::string Hourlngcharstr (Hourlngchar);
//std::string Minutelngcharstr (Minutelngchar);
//std::string Seconddblcharstr (Seconddblchar);

//std::string Yearlngcharstr=boost::lexical_cast<std::string>(Yearlngchar);
//std::string Monthlngcharstr=boost::lexical_cast<std::string>(Monthlngchar);
//std::string Daylngcharstr=boost::lexical_cast<std::string>(Daylngchar);
//std::string Hourlngcharstr=boost::lexical_cast<std::string>(Hourlngchar);
//std::string Minutelngcharstr=boost::lexical_cast<std::string>(Minutelngchar);
//std::string Seconddblcharstr=boost::lexical_cast<std::string>(Seconddblchar);

char yearn[1000];
char monthn[1000];
char dayn[1000];
char hourn[1000];
char minuten[1000];
char secondn[1000];

std::size_t size = std::strlen( Yearlngchar );
if (size==1) {
strcpy (yearn,"000");
strcat (yearn,Yearlngchar);
//Yearlngcharstr="000"+Yearlngcharstr;
}
if (size==2) {
strcpy (yearn,"00");
strcat (yearn,Yearlngchar);
//Yearlngcharstr="00"+Yearlngcharstr;
}
if (size==3) {
strcpy (yearn,"0");
strcat (yearn,Yearlngchar);
//Yearlngcharstr="0"+Yearlngcharstr;
}
if (size==4) {
strcpy (yearn,Yearlngchar);
//Yearlngcharstr="0"+Yearlngcharstr;
}

size = std::strlen( Monthlngchar );
if (size==1) {
strcpy (monthn,"0");
strcat (monthn,Monthlngchar);
//Monthlngcharstr="0"+Monthlngcharstr;
}
if (size==2) {
strcpy (monthn,Monthlngchar);
//Monthlngcharstr="0"+Monthlngcharstr;
}

size = std::strlen( Daylngchar );
if (size==1) {
strcpy (dayn,"0");
strcat (dayn,Daylngchar);
//Daylngcharstr="0"+Daylngcharstr;
}
if (size==2) {
strcpy (dayn,Daylngchar);
//Daylngcharstr="0"+Daylngcharstr;
}

size = std::strlen( Hourlngchar );
if (size==1) {
strcpy (hourn,"0");
strcat (hourn,Hourlngchar);
//Hourlngcharstr="0"+Hourlngcharstr;
}
if (size==2) {
strcpy (hourn,Hourlngchar);
//Hourlngcharstr="0"+Hourlngcharstr;
}

size = std::strlen( Minutelngchar );
if (size==1) {
strcpy (minuten,"0");
strcat (minuten,Minutelngchar);
//Minutelngcharstr="0"+Minutelngcharstr;
}
if (size==2) {
strcpy (minuten,Minutelngchar);
//Minutelngcharstr="0"+Minutelngcharstr;
}

size = std::strlen( Seconddblchar );
if (size==1) {
strcpy (secondn,"0");
strcat (secondn,Seconddblchar);
//Seconddblcharstr="0"+Seconddblcharstr;
}
if (size==2) {
strcpy (secondn,Seconddblchar);
//Seconddblcharstr="0"+Seconddblcharstr;
}

//std::string fulldatetime;

//fulldatetime=Yearlngcharstr+"-"+Monthlngcharstr+"-"+Daylngcharstr+" "+Hourlngcharstr+":"+Minutelngcharstr;

//char fulldatetimechar = new char[1000];
char fulldatetimechar[1000];
strcpy (fulldatetimechar,yearn);
strcat (fulldatetimechar,"-");
strcat (fulldatetimechar,monthn);
strcat (fulldatetimechar,"-");
strcat (fulldatetimechar,dayn);
strcat (fulldatetimechar," ");
strcat (fulldatetimechar,hourn);
strcat (fulldatetimechar,":");
strcat (fulldatetimechar,minuten);
//strcat (fulldatetimechar,":");
//strcat (fulldatetimechar,secondn);

//std::string fulldatetimecharstr=boost::lexical_cast<std::string>(fulldatetimechar);
//std::string fulldatetimecharstr(1, fulldatetimechar); std::cout << fulldatetimecharstr << std::endl;
//std::cout << std::string(1, fulldatetimechar) << std::endl;

//sprintf(debugmsg,"%s",fulldatetimechar);MessageBox( NULL, debugmsg,"Debug",MB_OK); 
//sprintf(debugmsg,"%s",monthn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",dayn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",hourn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",minuten);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",secondn);MessageBox( NULL, debugmsg,"Debug",MB_OK);

//writable = new char[S1str.size() + 1];
//std::copy(S1str.begin(), S1str.end(), writable);
//writable[S1str.size()] = '\0'; // don't forget the terminating 0


//char *fulldatetimechar = new char[fulldatetime.length() + 1]; // or
//std::strcpy(fulldatetimechar, fulldatetime.c_str());
      
//----
   return(fulldatetimechar);
  }

char* current_time()
{

    long int t = static_cast<long int>(time(NULL));
    char timechar[1000];
    sprintf(timechar,"%u",t);
    return timechar;
}

char* date_to_unix_time(char* parameters)
{

static char parameterss[1000];
strncpy(parameterss, parameters, 1000);

// Parameters decomposition
long Y1;
long M1;
long D1;
int H1;
int m1;
int S1;

char * writable;

std::string linestr (parameterss);  
          
std::size_t found = linestr.find(";");        
std::string Y1str = linestr.substr (0,found);
writable = new char[Y1str.size() + 1];
std::copy(Y1str.begin(), Y1str.end(), writable);
writable[Y1str.size()] = '\0'; // don't forget the terminating 0           
Y1=atol(writable);

linestr.assign(linestr.begin()+found+1,linestr.end());
found = linestr.find(";");
std::string M1str = linestr.substr (0,found);
writable = new char[M1str.size() + 1];
std::copy(M1str.begin(), M1str.end(), writable);
writable[M1str.size()] = '\0'; // don't forget the terminating 0
M1=atol(writable);

linestr.assign(linestr.begin()+found+1,linestr.end());
found = linestr.find(";");
std::string D1str = linestr.substr (0,found);
writable = new char[D1str.size() + 1];
std::copy(D1str.begin(), D1str.end(), writable);
writable[D1str.size()] = '\0'; // don't forget the terminating 0
D1=atol(writable);

linestr.assign(linestr.begin()+found+1,linestr.end());
found = linestr.find(";");
std::string H1str = linestr.substr (0,found);
writable = new char[H1str.size() + 1];
std::copy(H1str.begin(), H1str.end(), writable);
writable[H1str.size()] = '\0'; // don't forget the terminating 0
H1=atoi(writable);

linestr.assign(linestr.begin()+found+1,linestr.end());
found = linestr.find(";");
std::string m1str = linestr.substr (0,found);
writable = new char[m1str.size() + 1];
std::copy(m1str.begin(), m1str.end(), writable);
writable[m1str.size()] = '\0'; // don't forget the terminating 0
m1=atoi(writable);

linestr.assign(linestr.begin()+found+1,linestr.end());
found = linestr.find(";");
std::string S1str = linestr.substr (0,found);
writable = new char[S1str.size() + 1];
std::copy(S1str.begin(), S1str.end(), writable);
writable[S1str.size()] = '\0'; // don't forget the terminating 0
S1=atoi(writable);

double dayssince111970;
dayssince111970=dateserial(1970,1,1);

double dayssincespecified;
dayssincespecified=dateserial(Y1,M1,D1);

double daysdif=dayssincespecified-dayssince111970;

double inseconds=daysdif*24*60*60;
inseconds+=H1*60*60+m1*60+S1;
//inseconds-=3600;

char catline[1000];
sprintf(catline,"%f",inseconds);

return catline;
}

long dateserial(long y,long m,long d)
{
    //declare
    long dayscount;long dayofmonth;long year;long month;

    //initialize
    dayscount = d;

    //process
    if (m > 1) {
        month = m;
        dayofmonth = 1040154527;
        if (((month > 2) && isleapyear(y))==1) dayofmonth = (dayofmonth + 32);
        do {
            dayscount = dayscount + (dayofmonth & 31);
            if (month == 2) break;
            month--;
            dayofmonth = trunc(round(dayofmonth) / 32);
            if (dayofmonth == 0) dayofmonth = 1072692223;
           }
        while (1==1);
               }

    //exit
    year = (y - 1);
    return (dayscount + (trunc(year) * 365) + (trunc(round(year) / 4)) - (trunc(round(year) / 100)) + (trunc(round(year) / 400)));
}

int timedayofweek(double timeb)
{
//double result;
//result= fmod (static_cast<double>(timeb),7);

/*
if (result==0) return 4;
if (result==1) return 3;
if (result==2) return 2;
if (result==3) return 1;
if (result==4) return 0;
if (result==5) return 6;
if (result==6) return 5;
*/

/*
char* mydate;
mydate=ut_to_date(timeb);
char * writable;

std::string mydatestr (mydate);                 
std::string daystr = mydatestr.substr (0,3);
writable = new char[daystr.size() + 1];
std::copy(daystr.begin(), daystr.end(), writable);
writable[daystr.size()] = '\0'; // don't forget the terminating 0           

if (strcmp(writable,"Mon")==0) { return 1; }
if (strcmp(writable,"Tue")==0) { return 2; }
if (strcmp(writable,"Wed")==0) { return 3; }
if (strcmp(writable,"Thu")==0) { return 4; }
if (strcmp(writable,"Fri")==0) { return 5; }
if (strcmp(writable,"Sat")==0) { return 6; }
if (strcmp(writable,"Sun")==0) { return 0; }
*/

double dayofweek=fmod( ( floor ( timeb / 86400 ) + 4 ) ,7 ) ;

//static char debugmsg[1000];
//sprintf(debugmsg,"%f",dayofweek);MessageBox( NULL, debugmsg,"Debug",MB_OK); 

int dayofweekint;
dayofweekint =  static_cast<int>(dayofweek);

//sprintf(debugmsg,"%i",dayofweekint);MessageBox( NULL, debugmsg,"Debug",MB_OK);

return dayofweekint;

}

char* unix_time_to_datecpp(double DateSerialchar)
  {


//static char DateSerialcharr[1000];
//    strncpy(DateSerialcharr, DateSerialchar, 1000);
    double dblDateSerialchar=DateSerialchar;

 double DateSerialdbl=dblDateSerialchar;
static long Yearlng;
static long Monthlng;
static long Daylng;
static long Hourlng;
static long Minutelng;
static double Seconddbl;

//DateSerialdbl=1111111111;
static char debugmsg[1000];
//sprintf(debugmsg,"%f",DateSerialdbl);MessageBox( NULL, debugmsg,"Debug",MB_OK); 

DateFromSerial(DateSerialdbl , Yearlng , Monthlng , Daylng,Hourlng,Minutelng,Seconddbl);

long Secondlng=Seconddbl;

//sprintf(debugmsg,"%u",Yearlng);MessageBox( NULL, debugmsg,"Debug",MB_OK); 

char Yearlngchar[1000];
sprintf(Yearlngchar,"%u",Yearlng);

char Monthlngchar[1000];
sprintf(Monthlngchar,"%u",Monthlng);

char Daylngchar[1000];
sprintf(Daylngchar,"%u",Daylng);

char Hourlngchar[1000];
sprintf(Hourlngchar,"%u",Hourlng);

char Minutelngchar[1000];
sprintf(Minutelngchar,"%u",Minutelng);

char Seconddblchar[1000];
sprintf(Seconddblchar,"%u",Secondlng);


//std::string Yearlngcharstr (Yearlngchar);
//std::string Monthlngcharstr (Monthlngchar);
//std::string Daylngcharstr (Daylngchar);
//std::string Hourlngcharstr (Hourlngchar);
//std::string Minutelngcharstr (Minutelngchar);
//std::string Seconddblcharstr (Seconddblchar);

//std::string Yearlngcharstr=boost::lexical_cast<std::string>(Yearlngchar);
//std::string Monthlngcharstr=boost::lexical_cast<std::string>(Monthlngchar);
//std::string Daylngcharstr=boost::lexical_cast<std::string>(Daylngchar);
//std::string Hourlngcharstr=boost::lexical_cast<std::string>(Hourlngchar);
//std::string Minutelngcharstr=boost::lexical_cast<std::string>(Minutelngchar);
//std::string Seconddblcharstr=boost::lexical_cast<std::string>(Seconddblchar);

char yearn[1000];
char monthn[1000];
char dayn[1000];
char hourn[1000];
char minuten[1000];
char secondn[1000];

std::size_t size = std::strlen( Yearlngchar );
if (size==1) {
strcpy (yearn,"000");
strcat (yearn,Yearlngchar);
//Yearlngcharstr="000"+Yearlngcharstr;
}
if (size==2) {
strcpy (yearn,"00");
strcat (yearn,Yearlngchar);
//Yearlngcharstr="00"+Yearlngcharstr;
}
if (size==3) {
strcpy (yearn,"0");
strcat (yearn,Yearlngchar);
//Yearlngcharstr="0"+Yearlngcharstr;
}
if (size==4) {
strcpy (yearn,Yearlngchar);
//Yearlngcharstr="0"+Yearlngcharstr;
}

size = std::strlen( Monthlngchar );
if (size==1) {
strcpy (monthn,"0");
strcat (monthn,Monthlngchar);
//Monthlngcharstr="0"+Monthlngcharstr;
}
if (size==2) {
strcpy (monthn,Monthlngchar);
//Monthlngcharstr="0"+Monthlngcharstr;
}

size = std::strlen( Daylngchar );
if (size==1) {
strcpy (dayn,"0");
strcat (dayn,Daylngchar);
//Daylngcharstr="0"+Daylngcharstr;
}
if (size==2) {
strcpy (dayn,Daylngchar);
//Daylngcharstr="0"+Daylngcharstr;
}

size = std::strlen( Hourlngchar );
if (size==1) {
strcpy (hourn,"0");
strcat (hourn,Hourlngchar);
//Hourlngcharstr="0"+Hourlngcharstr;
}
if (size==2) {
strcpy (hourn,Hourlngchar);
//Hourlngcharstr="0"+Hourlngcharstr;
}

size = std::strlen( Minutelngchar );
if (size==1) {
strcpy (minuten,"0");
strcat (minuten,Minutelngchar);
//Minutelngcharstr="0"+Minutelngcharstr;
}
if (size==2) {
strcpy (minuten,Minutelngchar);
//Minutelngcharstr="0"+Minutelngcharstr;
}

size = std::strlen( Seconddblchar );
if (size==1) {
strcpy (secondn,"0");
strcat (secondn,Seconddblchar);
//Seconddblcharstr="0"+Seconddblcharstr;
}
if (size==2) {
strcpy (secondn,Seconddblchar);
//Seconddblcharstr="0"+Seconddblcharstr;
}

//sprintf(debugmsg,"%s",monthn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",dayn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",hourn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",minuten);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",secondn);MessageBox( NULL, debugmsg,"Debug",MB_OK);

//std::string fulldatetime;

//fulldatetime=Yearlngcharstr+"-"+Monthlngcharstr+"-"+Daylngcharstr+" "+Hourlngcharstr+":"+Minutelngcharstr;

//char fulldatetimechar = new char[1000];
char fulldatetimechar[1000];
strcpy (fulldatetimechar,yearn);
strcat (fulldatetimechar,"-");
strcat (fulldatetimechar,monthn);
strcat (fulldatetimechar,"-");
strcat (fulldatetimechar,dayn);
strcat (fulldatetimechar," ");
strcat (fulldatetimechar,hourn);
strcat (fulldatetimechar,":");
strcat (fulldatetimechar,minuten);
//strcat (fulldatetimechar,":");
//strcat (fulldatetimechar,secondn);

//std::string fulldatetimecharstr=boost::lexical_cast<std::string>(fulldatetimechar);
//std::string fulldatetimecharstr(1, fulldatetimechar); std::cout << fulldatetimecharstr << std::endl;
//std::cout << std::string(1, fulldatetimechar) << std::endl;

//sprintf(debugmsg,"%s",monthn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",dayn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",hourn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",minuten);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",secondn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",fulldatetimechar);MessageBox( NULL, debugmsg,"Debug",MB_OK); 


//writable = new char[S1str.size() + 1];
//std::copy(S1str.begin(), S1str.end(), writable);
//writable[S1str.size()] = '\0'; // don't forget the terminating 0


//char *fulldatetimechar = new char[fulldatetime.length() + 1]; // or
//std::strcpy(fulldatetimechar, fulldatetime.c_str());
      
//----
   return(fulldatetimechar);
}



char* timedayofweekqc(char* DateSerialchar)
  {


static char DateSerialcharr[1000];
    strncpy(DateSerialcharr, DateSerialchar, 1000);
    double dblDateSerialchar=atof(DateSerialcharr);

 double DateSerialdbl=dblDateSerialchar;
static long Yearlng;
static long Monthlng;
static long Daylng;
static long Hourlng;
static long Minutelng;
static double Seconddbl;

//DateSerialdbl=1111111111;
static char debugmsg[1000];
//sprintf(debugmsg,"%f",DateSerialdbl);MessageBox( NULL, debugmsg,"Debug",MB_OK); 

DateFromSerial(DateSerialdbl , Yearlng , Monthlng , Daylng,Hourlng,Minutelng,Seconddbl);

long Secondlng=Seconddbl;

//sprintf(debugmsg,"%u",Yearlng);MessageBox( NULL, debugmsg,"Debug",MB_OK); 

//arrayoflongs offset;
//arrayofchars week;

//sprintf(debugmsg,"%s","0");MessageBox( NULL, debugmsg,"Debug",MB_OK); 

//char writable[1000];
//std::string week0 = "Sunday";
//writable = new char[week0.size() + 1];
//std::copy(week0.begin(), week0.end(), writable);
//writable[week0.size()] = '\0'; // don't forget the terminating 0
//strcpy (week[0],writable);  

//sprintf(debugmsg,"%s",week[0]);MessageBox( NULL, debugmsg,"Debug",MB_OK); 

//char writable[1000];
//std::size_t size = std::strlen( Yearlngchar );
//strcpy (writable,"Sunday");
//strcpy (week[0],writable);
//sprintf(debugmsg,"%s",week[0]);MessageBox( NULL, debugmsg,"Debug",MB_OK); 
         
//week[0]=writable;
//sprintf(debugmsg,"%s","0");MessageBox( NULL, debugmsg,"Debug",MB_OK); 
//strcpy (week[0],"Sunday");
//strcpy (week[1],"Monday");
//strcpy (week[2],"Tuesday");
//strcpy (week[3],"Wednesday");
//strcpy (week[4],"Thursday");
//strcpy (week[5],"Friday");
//strcpy (week[6],"Saturday");

//std::string s = "Sunday";
//char cstr[s.size() + 1];
//strcpy(cstr, s.c_str());    // or pass &s[0]

//std::vector<std::string> week;
//week.push_back("Sunday");
//week.push_back("Monday");

//char writable[1000];
//std::vector<char> week;
//strcpy (writable,"Sunday");
//week.push_back(writable);


//char test[] = "Sunday";
//std::vector<char> week(test, test + sizeof(test)/sizeof(*test));

//std::vector<char> vbuffer;

//std::vector<char> week;
//std::string s = "Sunday";
//std::copy(s.begin(), s.end(), std::back_inserter(week));

std::vector<std::string> myv;
char mydayofweek0[] = "Sunday";  // This will add a terminating \0 character to the array
myv.push_back(mydayofweek0);
char mydayofweek1[] = "Monday";  // This will add a terminating \0 character to the array
myv.push_back(mydayofweek1);
char mydayofweek2[] = "Tuesday";  // This will add a terminating \0 character to the array
myv.push_back(mydayofweek2);
char mydayofweek3[] = "Wednesday";  // This will add a terminating \0 character to the array
myv.push_back(mydayofweek3);
char mydayofweek4[] = "Thursday";  // This will add a terminating \0 character to the array
myv.push_back(mydayofweek4);
char mydayofweek5[] = "Friday";  // This will add a terminating \0 character to the array
myv.push_back(mydayofweek5);
char mydayofweek6[] = "Saturday";  // This will add a terminating \0 character to the array
myv.push_back(mydayofweek6);

std::vector<char*>  vc;
std::transform(myv.begin(), myv.end(), std::back_inserter(vc), convert);   

//sprintf(debugmsg,"%s",vc[6]);MessageBox( NULL, debugmsg,"Debug",MB_OK);

std::vector<long> offset;
offset.push_back(0);
offset.push_back(31);
offset.push_back(59);
offset.push_back(90);
offset.push_back(120);
offset.push_back(151);
offset.push_back(181);
offset.push_back(212);
offset.push_back(243);
offset.push_back(273);
offset.push_back(304);
offset.push_back(334);

//sprintf(debugmsg,"%u",offset[1]);MessageBox( NULL, debugmsg,"Debug",MB_OK);

long afterFeb,dayOfWeek,aux;

afterFeb = 1;
if (Monthlng > 2) afterFeb = 0;
aux = Yearlng - 1700 - afterFeb;
// dayOfWeek for 1700/1/1 = 5, Friday
dayOfWeek  = 5;
// partial sum of days betweem current date and 1700/1/1
dayOfWeek = dayOfWeek + (aux + afterFeb) * 365;
// leap year correction    
dayOfWeek = dayOfWeek + aux / 4 - aux / 100 + (aux + 100) / 400;     
// sum monthly and day offsets
dayOfWeek = dayOfWeek + offset[Monthlng - 1] + (Daylng - 1);               
dayOfWeek = dayOfWeek % 7; // x %= 3 same as x = x % 3

//sprintf(debugmsg,"%u",dayOfWeek);MessageBox( NULL, debugmsg,"Debug",MB_OK);

char dayofweekchar[1000];
sprintf(dayofweekchar,"%u",dayOfWeek);

return dayofweekchar; //week[dayOfWeek] 

}

char* calculate_seconds_since_1_1_1970_cpp(char* parameters)
{

static char parameterss[1000];
strncpy(parameterss, parameters, 1000);

// Parameters decomposition
long Y1;
long M1;
long D1;
int H1;
int m1;
int S1;
//double x;
//char* serr;

char * writable;

std::string linestr (parameterss);  
          
std::size_t found = linestr.find(";");        
std::string Y1str = linestr.substr (0,found);
writable = new char[Y1str.size() + 1];
std::copy(Y1str.begin(), Y1str.end(), writable);
writable[Y1str.size()] = '\0'; // don't forget the terminating 0           
Y1=atol(writable);

linestr.assign(linestr.begin()+found+1,linestr.end());
found = linestr.find(";");
std::string M1str = linestr.substr (0,found);
writable = new char[M1str.size() + 1];
std::copy(M1str.begin(), M1str.end(), writable);
writable[M1str.size()] = '\0'; // don't forget the terminating 0
M1=atol(writable);

linestr.assign(linestr.begin()+found+1,linestr.end());
found = linestr.find(";");
std::string D1str = linestr.substr (0,found);
writable = new char[D1str.size() + 1];
std::copy(D1str.begin(), D1str.end(), writable);
writable[D1str.size()] = '\0'; // don't forget the terminating 0
D1=atol(writable);

linestr.assign(linestr.begin()+found+1,linestr.end());
found = linestr.find(";");
std::string H1str = linestr.substr (0,found);
writable = new char[H1str.size() + 1];
std::copy(H1str.begin(), H1str.end(), writable);
writable[H1str.size()] = '\0'; // don't forget the terminating 0
H1=atoi(writable);

linestr.assign(linestr.begin()+found+1,linestr.end());
found = linestr.find(";");
std::string m1str = linestr.substr (0,found);
writable = new char[m1str.size() + 1];
std::copy(m1str.begin(), m1str.end(), writable);
writable[m1str.size()] = '\0'; // don't forget the terminating 0
m1=atoi(writable);

linestr.assign(linestr.begin()+found+1,linestr.end());
found = linestr.find(";");
std::string S1str = linestr.substr (0,found);
writable = new char[S1str.size() + 1];
std::copy(S1str.begin(), S1str.end(), writable);
writable[S1str.size()] = '\0'; // don't forget the terminating 0
S1=atoi(writable);

double dayssince111970;
dayssince111970=dateserial(1970,1,1);

double dayssincespecified;
dayssincespecified=dateserial(Y1,M1,D1);

double daysdif=dayssincespecified-dayssince111970;

double inseconds=daysdif*24*60*60;
inseconds+=H1*60*60+m1*60+S1;

char catline[1000];
sprintf(catline,"%f",inseconds);

return catline;
}